<?
include("config.inc.php");
session_name("spamassassin");
session_start();


// if user is already logged in, ie the "username" session var is already
// registered, then un-register, thus logging that user out automatically

if(isset($_SESSION["username"]) ) {
  unset($_SESSION["username"]);
}

// if $usesssl is enabled, then check if the request is made with HTTPS,
// SSL, on, and if not, redirect to the HTTPS server.

if (strtolower($usessl) == 'yes') {
  $baselocation = "https://$sitename";
} else {
  $baselocation = "http://$sitename";
}
if ($phpsapath != "") {
  $baselocation .= "/$phpsapath";
}

if(!strtolower($_SERVER['HTTPS']) == 'on' and strtolower($usessl) == 'yes') {
  $location = "$baselocation/login.php";
  header("Location: $location");
  exit;
}


$status = -1; 		// init the pwauth return status var
$loginerror = 0;

if($post_login) {

/*
 * START AUTHENTICATION SYSTEM
 */

// this simple routine opens a pipe to the pwauth program, and 
// pipes the username / password to pwauth, then closing it, 
// checking the return value. 
// A return value of 0 = successful login, 1 = failed login

  #IS THIS THE GLOBAL USER?
  #echo "DEBUG -- $global_username / $global_password<BR>\n";
  #echo "DEBUG -- $post_username / $post_password<BR>\n";
  if ((strtoupper($post_username) == $global_username) or ($global_override > 0)) {
    $status = 1;
    #echo "DEBUG -- $global_override -- In GLOBAL AUTH<BR>\n";
    if ($post_password == $global_password) {
      $status = 0;
    }
  }

  #JUST A SMALL CHANGE TO UPPERCASE @GLOBAL FOR THE DATABASE
  if (strtoupper($post_username) == $global_username) {
    $post_username = strtoupper($post_username);
  }

  if ($status != 0) {
    #use standard auth routine
    if (strtoupper($pwauth_prog) == "CHECKPASSWORD") {
      #if (version_compare('4.3.0',phpversion(),'>=') ) die ("PHP version 4.3.0 or greater is required.");
      $timestamp = time();
      $pwauth = "echo -en \"".escapeshellcmd($post_username)."\\000".escapeshellcmd($post_password)."\\000$timestamp\\000\" | $pwauth_cmd";
      exec ($pwauth, $output, $status);
      #echo "DEBUG: $status -- $pwauth<BR>\n";
    } else {
      $pwauth = "echo -e \"".escapeshellcmd($post_username)."\n".escapeshellcmd($post_password)."\n\" | $pwauth_cmd";
    }
  
    exec ($pwauth, $output, $status);
 
    #NO LONGER SEEMS TO WORK WITH NEWER PHP 
    #if($cmd = popen ($pwauth, "w")) {
    #  fwrite($cmd, $pipe);
    #  $status=(pclose($cmd)>>8)&0xFF;
    #}

    #print "ERROR FLAG : ".(join("",$status))."<BR>\n";

    #echo "DEBUG: $status<BR>\n";
  }

/*
 * STOP AUTHENTICATION SYSTEM
 */

  if($status == 0) {

    // login successful, redirect to index.php, checking to see
    // if redirect should use SSL or not.
    //$loginerror = 0;
    $username = $post_username;
    $_SESSION['username'] = $username;
    $location = "$baselocation/index.php"; 
    header("Location: $location");
    exit;
  } else {
    $loginerror = 1;
  }
}

/*
 * Below is the login form.  You can change the html to suit your needs
 * however you want, makeing sure that you keep the form field names the
 * same. 
 *
 * The required form field names:
 *
 * login	this is a hidden field to indicat that the form should
 *		be processed.
 *
 * username	this is the username entered
 *
 * password 	this is the password entered
 *
 */

include("header.inc.php");

?>
<form action="<?PHP echo "$baselocation/login.php"; ?>" method=post>
<input type=hidden name=login value=1>
<CENTER><font class=mainheading>PHP-SpamAssassin Configuration User Login</font></CENTER>
<BR>
<table BORDER=0 ALIGN=CENTER>
<?
if($loginerror > 0) {
?>
	<tr>
		<td colspan=2><font class=main><b>Login Failed, Please try again!</b></font></td>
	</tr>
<?
}
?>
	<tr>
		<td ALIGN=RIGHT><font class=main>Username:</font></td>
		<td><input name=username type=text size=20 maxlength=20></td>
	</tr>
	<tr>
		<td ALIGN=right><font class=main>Password:</font></td>
		<td><input name=password type=password size=20></td>
	</tr>
	<tr>
		<td colspan=2 align=center><input type=submit name=submit value="Login"></td>
	</tr>
</table>
</form>

<?
include("footer.inc.php");
?>

